<?php
namespace Claromentis\Core\Component;

$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"] ?: array()) + array("defaul" . "t" => base64_decode("ZGVmYXVsd" . "A=="), "_e608e5b5c4c34a67ba97ef84" . "c1e16199" => base64_decode("Jw" . "=="), "_49c6565477ee9f822b499a53e" . "6d2995f" => base64_decode("YXJyYXlfa2V5X2V4aXN" . "0cw=="), "_989417b3b0bd1f9e7489aec1a9" . "477a7c" => base64_decode("ZGVmYXVsdF9zdHJpbmc" . "="), "ty" . "pe" => base64_decode("dHlwZQ" . "=="), "_d706c160e45bf7" . "434fff82a5976f0" . "e19" => base64_decode("YXJyYXlfa2V5cw=" . "="), "_a31b91400b051f09" . "bc154d683443056b" => base64_decode("SW52YWxpZ" . "CBvcHRpb2" . "5zIGtleSA" . "n"));
use Claromentis\Core\Component\Exception\UnknownOptionException;
use Claromentis\Core\Component\ValueType\ValueType;
use Claromentis\Core\Component\ValueType\ValueTypeFactory;




class ValidatingOptions implements OptionsInterface
{
    protected $types = [];
    protected $values = [];
    
    
    
    
    
    
    
    
    
    
    public function __construct(array $_611d4f00b5d81631c8a2f6e92983631f = [], array $values = [])
    {
        foreach ($_611d4f00b5d81631c8a2f6e92983631f as $option_name => $_2eb87be11ba86628b66da5659d96a5e0) {
            
            
            $_2eb87be11ba86628b66da5659d96a5e0[$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["t" . "y" . "p" . "e"]] = ValueTypeFactory::Create($_2eb87be11ba86628b66da5659d96a5e0);
            
            
            $this->types[$option_name] = $_2eb87be11ba86628b66da5659d96a5e0;
        }
        foreach ($values as $name => $value) {
            if (!isset($this->types[$name])) {
                continue;
            }
            
            
            
            $this->values[$name] = $this->GetType($name)->Normalize($value);
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public static function CreateFromSerialized($_611d4f00b5d81631c8a2f6e92983631f, $attributes)
    {
        $_6faea2dba9305d4c6c801d8bf61aa85f = new static($_611d4f00b5d81631c8a2f6e92983631f);
        foreach ($attributes as $key => $value) {
            if (!isset($_6faea2dba9305d4c6c801d8bf61aa85f->types[$key])) {
                continue;
            }
            
            
            $_6faea2dba9305d4c6c801d8bf61aa85f->SetSerialized($key, $value);
        }
        return $_6faea2dba9305d4c6c801d8bf61aa85f;
    }
    public function Get($name)
    {
        if (!isset($this->types[$name])) {
            return null;
        }
        
        
        if (isset($this->values[$name])) {
            return $this->values[$name];
        }
        return $this->GetDefault($name);
    }
    
    
    
    
    
    
    public function GetAll()
    {
        $_1f24efd4735b7a11b391147435e7d35d = [];
        foreach ($this->GetKeys() as $key) {
            $_1f24efd4735b7a11b391147435e7d35d[$key] = $this->Get($key);
        }
        return $_1f24efd4735b7a11b391147435e7d35d;
    }
    public function GetKeys()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_d706c160e45bf7434fff82a" . "5976f0e19"]($this->types);
    }
    
    
    
    
    
    
    
    
    
    public function IsDefault($key)
    {
        if (!isset($this->values[$key])) {
            return true;
        }
        $value = $this->Get($key);
        $default = $this->GetDefault($key);
        return $default === $value;
    }
    
    
    
    
    
    
    
    
    
    public function GetType($key)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_49c6565477ee9f822b499a53e6d" . "2995f"]($key, $this->types)) {
            throw new UnknownOptionException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_a31b91400b051f09bc154d683443" . "056b"] . $key . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_e608e5b5c4c34a67ba97ef" . "84c1e16199"]);
        }
        return $this->types[$key][$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["t" . "y" . "p" . "e"]];
    }
    
    
    
    
    
    
    
    
    
    public function GetSerialized($key)
    {
        $type = $this->GetType($key);
        return $type->Serialize($this->Get($key));
    }
    protected function SetSerialized($key, $_d957779c7daa148ba3e831d162d15722)
    {
        $type = $this->GetType($key);
        $this->values[$key] = $type->Unserialize($_d957779c7daa148ba3e831d162d15722);
    }
    
    
    
    
    
    
    
    public function GetDefault($key)
    {
        if (isset($this->types[$key][$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["de" . "fa" . "ul" . "t"]])) {
            return $this->types[$key][$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["defa" . "ult"]];
        }
        if (!isset($this->types[$key][$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_989417b" . "3b0bd1f9" . "e7489aec" . "1a9477a7" . "c"]])) {
            return null;
        }
        $type = $this->GetType($key);
        $_989417b3b0bd1f9e7489aec1a9477a7c = $this->types[$key][$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_989417b3b0bd1f9e74" . "89aec1a9477a7c"]];
        $default = $type->Unserialize($_989417b3b0bd1f9e7489aec1a9477a7c);
        $this->types[$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["defa" . "ult"]] = $default;
        return $default;
    }
}